//
// Source code recreated from a .class file by IntelliJ IDEA
// (powered by FernFlower decompiler)
//

package com.tiptimes.service.impl;

import com.tiptimes.dao.MaterialClassBindingDao;
import com.tiptimes.dao.MaterialClassDao;
import com.tiptimes.dao.MaterialInformationDao;
import com.tiptimes.model.MaterialClass;
import com.tiptimes.model.MaterialClassBinding;
import com.tiptimes.model.MaterialInformation;
import com.tiptimes.service.MaterialService;
import java.util.ArrayList;
import java.util.Iterator;
import java.util.List;
import java.util.Map;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;
import org.springframework.transaction.annotation.Transactional;

@Service
public class MaterialServiceImpl implements MaterialService {
    @Autowired
    private MaterialInformationDao materialInformationDao;
    @Autowired
    private MaterialClassBindingDao materialClassBindingDao;
    @Autowired
    private MaterialClassDao materialClassDao;

    public MaterialServiceImpl() {
    }

    @Transactional
    public void deleteMaterialInformation(String id) {
        this.materialInformationDao.deleteMaterialInformation(id);
    }

    public List<MaterialClass> listMaterialClassSustratumByUpClassID(String spaceMessageID) {
        List<MaterialClass> materialClass_ALL_list = this.materialClassDao.listMaterialClassSustratumBySpaceMessageID(spaceMessageID);
        if (materialClass_ALL_list.size() == 0) {
            return null;
        } else {
            List<MaterialClass> materialClass_UP_list = this.materialClassDao.listMaterialClassSustratumByUpClassID(spaceMessageID, "0");

            for(int i = 1; materialClass_UP_list.size() < materialClass_ALL_list.size(); ++i) {
                List<MaterialClass> materialClass_UP_list_i = this.materialClassDao.listMaterialClassSustratumByUpClassID(spaceMessageID, ((MaterialClass)materialClass_UP_list.get(i - 1)).getClassID());
                if (materialClass_UP_list_i.size() != 0) {
                    int t = i;

                    for(Iterator var7 = materialClass_UP_list_i.iterator(); var7.hasNext(); ++t) {
                        MaterialClass materialClass_UP_list_i_i = (MaterialClass)var7.next();
                        if ("0".equals(((MaterialClass)materialClass_UP_list.get(i - 1)).getUpClassID())) {
                            materialClass_UP_list_i_i.setClassName("|--" + materialClass_UP_list_i_i.getClassName());
                        } else {
                            materialClass_UP_list_i_i.setClassName("   |--" + materialClass_UP_list_i_i.getClassName());
                        }

                        materialClass_UP_list.add(t, materialClass_UP_list_i_i);
                    }
                }
            }

            return materialClass_UP_list;
        }
    }

    public List<MaterialClass> listMaterialClassSustratumByUpClassIDNo(String spaceMessageID) {
        List<MaterialClass> materialClass_ALL_list = this.materialClassDao.listMaterialClassSustratumBySpaceMessageID(spaceMessageID);
        return materialClass_ALL_list.size() == 0 ? null : materialClass_ALL_list;
    }

    public List<MaterialInformation> listMaterialInformationBySpaceMessageID(String spaceMessageID) {
        List<MaterialInformation> spaceMaterialInformation_list = this.materialInformationDao.listMaterialInformationBySpaceMessageID(spaceMessageID);
        return spaceMaterialInformation_list.size() == 0 ? null : spaceMaterialInformation_list;
    }

    public List<MaterialInformation> listMaterialInformationBySpaceMessageIDAndOthers(String spaceMessageID, MaterialInformation materialInformation) {
        List<MaterialInformation> spaceMaterialInformation_list = this.materialInformationDao.listMaterialInformationBySpaceMessageIDAndOthers(spaceMessageID, materialInformation);
        return spaceMaterialInformation_list.size() == 0 ? null : spaceMaterialInformation_list;
    }

    public List<MaterialInformation> listMaterialInformationBySpaceMessageIDAndEducationState(String spaceMessageID, int educationState) {
        List<MaterialInformation> spaceMaterialInformation_list = this.materialInformationDao.listMaterialInformationBySpaceMessageIDAndEducationState(spaceMessageID, educationState + "");
        return spaceMaterialInformation_list.size() == 0 ? null : spaceMaterialInformation_list;
    }

    public List<MaterialInformation> listMaterialInformationByEducationState(int educationState) {
        List<MaterialInformation> spaceMaterialInformation_list = this.materialInformationDao.listMaterialInformationByEducationState(educationState + "");
        return spaceMaterialInformation_list.size() == 0 ? null : spaceMaterialInformation_list;
    }

    public List<MaterialInformation> listMaterialInformationByEducationStateAndOthers(int educationState, MaterialInformation materialInformation) {
        List<MaterialInformation> spaceMaterialInformation_list = this.materialInformationDao.listMaterialInformationByEducationStateAndOthers(educationState + "", materialInformation);
        return spaceMaterialInformation_list.size() == 0 ? null : spaceMaterialInformation_list;
    }

    public List<MaterialInformation> listMaterialInformationByClassID(String classID) {
        List<MaterialInformation> spaceMaterialInformation_list = this.materialInformationDao.listMaterialInformationByClassID(classID);
        return spaceMaterialInformation_list.size() == 0 ? null : spaceMaterialInformation_list;
    }

    public List<MaterialInformation> listMaterialInformationByClassIDAndOthers(String classID, MaterialInformation materialInformation) {
        List<MaterialInformation> spaceMaterialInformation_list = this.materialInformationDao.listMaterialInformationByClassIDAndOthers(classID, materialInformation);
        return spaceMaterialInformation_list.size() == 0 ? null : spaceMaterialInformation_list;
    }

    public MaterialInformation getMaterialInformationByInformationID(String informationID) {
        List<MaterialInformation> spaceMaterialInformation_list = this.materialInformationDao.listMaterialInformationByInformationID(informationID);
        if (spaceMaterialInformation_list.size() == 0) {
            return null;
        } else {
            if (!"0".equals(((MaterialInformation)spaceMaterialInformation_list.get(0)).getSpaceInformationID())) {
                String spaneName = this.materialInformationDao.getspaceMessageNameByInformationID(((MaterialInformation)spaceMaterialInformation_list.get(0)).getSpaceInformationID());
                List<Map<String, Object>> list = this.materialInformationDao.getFileIdByInformationID(((MaterialInformation)spaceMaterialInformation_list.get(0)).getSpaceInformationID());
                if (!list.isEmpty()) {
                    ((MaterialInformation)spaceMaterialInformation_list.get(0)).setFileId((String)((Map)list.get(0)).get("ExerciseFileID"));
                    ((MaterialInformation)spaceMaterialInformation_list.get(0)).setFileName((String)((Map)list.get(0)).get("ExerciseFileName"));
                }

                ((MaterialInformation)spaceMaterialInformation_list.get(0)).setSpaceMessageName(spaneName);
            }

            return (MaterialInformation)spaceMaterialInformation_list.get(0);
        }
    }

    public MaterialInformation listMaterialInformationByExerciseID(String exerciseID, String exerciseType) {
        List<MaterialInformation> spaceMaterialInformation_list = this.materialInformationDao.listMaterialInformationByExerciseID(exerciseID, exerciseType);
        return spaceMaterialInformation_list.size() == 0 ? null : (MaterialInformation)spaceMaterialInformation_list.get(0);
    }

    public MaterialInformation listMaterialInformationBySpaceInformationID(String spaceInformationID) {
        List<MaterialInformation> spaceMaterialInformation_list = this.materialInformationDao.listMaterialInformationBySpaceInformationID(spaceInformationID);
        return spaceMaterialInformation_list.size() == 0 ? null : (MaterialInformation)spaceMaterialInformation_list.get(0);
    }

    public List<MaterialClassBinding> listMaterialClassBinding(String informationID) {
        List<MaterialClassBinding> materialClassBinding_list = this.materialClassBindingDao.listMaterialClassBinding(informationID);
        return materialClassBinding_list.size() == 0 ? null : materialClassBinding_list;
    }

    @Transactional
    public void saveSpaceMaterialInformation(MaterialInformation spaceMaterialInformation, List<MaterialClassBinding> materialClassBinding_list) {
        this.materialInformationDao.saveMaterialInformation(spaceMaterialInformation);
        this.materialClassBindingDao.removeMaterialClassBinding(spaceMaterialInformation.getInformationID());
        Iterator var3 = materialClassBinding_list.iterator();

        while(var3.hasNext()) {
            MaterialClassBinding materialClassBinding_list_i = (MaterialClassBinding)var3.next();
            this.materialClassBindingDao.saveMaterialClassBinding(materialClassBinding_list_i);
        }

    }

    @Transactional
    public void updateSpaceMaterialInformation(MaterialInformation spaceMaterialInformation) {
        this.materialInformationDao.updateMaterialInformation(spaceMaterialInformation);
    }

    @Transactional
    public void updateSpaceMaterialInformation(MaterialInformation spaceMaterialInformation, List<MaterialClassBinding> materialClassBinding_list) {
        this.materialInformationDao.updateMaterialInformation(spaceMaterialInformation);
        this.materialClassBindingDao.removeMaterialClassBinding(spaceMaterialInformation.getInformationID());
        Iterator var3 = materialClassBinding_list.iterator();

        while(var3.hasNext()) {
            MaterialClassBinding materialClassBinding_list_i = (MaterialClassBinding)var3.next();
            this.materialClassBindingDao.saveMaterialClassBinding(materialClassBinding_list_i);
        }

    }

    public List<MaterialInformation> listMaterialInformationBySpaceMessageIDAndClassNameEnglish(String spaceMessageID, String classNameEnglish, int topNum, int num) {
        List<MaterialInformation> spaceMaterialInformation_list = this.materialInformationDao.listMaterialInformationBySpaceMessageIDAndClassNameEnglish(spaceMessageID, classNameEnglish, topNum, num);
        if (spaceMaterialInformation_list.size() == 0) {
            return null;
        } else {
            if ("0".equals(spaceMessageID)) {
                for(int i = 0; i < spaceMaterialInformation_list.size(); ++i) {
                    if (!"0".equals(((MaterialInformation)spaceMaterialInformation_list.get(i)).getSpaceInformationID())) {
                        String spaneName = this.materialInformationDao.getspaceMessageNameByInformationID(((MaterialInformation)spaceMaterialInformation_list.get(i)).getSpaceInformationID());
                        ((MaterialInformation)spaceMaterialInformation_list.get(i)).setSpaceMessageName(spaneName);
                    }
                }
            }

            return spaceMaterialInformation_list;
        }
    }

    public String listMaterialInformationBySpaceMessageIDAndClassNameEnglishSize(String spaceMessageID, String classNameEnglish) {
        String spaceMaterialInformation_list = this.materialInformationDao.listMaterialInformationBySpaceMessageIDAndClassNameEnglishSize(spaceMessageID, classNameEnglish);
        return spaceMaterialInformation_list;
    }

    public List<MaterialInformation> listMaterialInformationByCollectProjectList(String topUserID, String classNameEnglish, int topNum, int num) {
        List<MaterialInformation> spaceMaterialInformation_list = this.materialInformationDao.listMaterialInformationByCollectProjectList(topUserID, classNameEnglish, topNum, num);
        return spaceMaterialInformation_list.size() == 0 ? null : spaceMaterialInformation_list;
    }

    public String listMaterialInformationByCollectProjectSize(String topUserID, String classNameEnglish) {
        String spaceMaterialInformation_list = this.materialInformationDao.listMaterialInformationByCollectProjectSize(topUserID, classNameEnglish);
        return spaceMaterialInformation_list;
    }

    @Transactional
    public void updateMaterialInformationBySpaceMessageIDAndClassIDAndOrder1(String spaceMessageID, String classID, int order1, String informationID) {
        ArrayList materialInformation_order_list;
        int i;
        if (order1 != 99) {
            materialInformation_order_list = new ArrayList();

            for(i = 1; i <= 4; ++i) {
                List<MaterialInformation> materialInformation_list = this.materialInformationDao.listMaterialInformationBySpaceMessageIDAndClassIDAndOrder1(spaceMessageID, classID, i);
                if (materialInformation_list.size() != 0) {
                    if (informationID.equals(((MaterialInformation)materialInformation_list.get(0)).getInformationID())) {
                        break;
                    }

                    materialInformation_order_list.add(materialInformation_list.get(0));
                } else {
                    if (i >= order1) {
                        break;
                    }

                    materialInformation_order_list.add((Object)null);
                }
            }

            for(i = order1 - 1; i < materialInformation_order_list.size(); ++i) {
                if (materialInformation_order_list.get(i) != null) {
                    if (i == 3) {
                        this.materialInformationDao.updateMaterialInformationOrder1(((MaterialInformation)materialInformation_order_list.get(i)).getInformationID(), 99);
                        return;
                    }

                    this.materialInformationDao.updateMaterialInformationOrder1(((MaterialInformation)materialInformation_order_list.get(i)).getInformationID(), i + 2);
                }
            }
        } else {
            materialInformation_order_list = new ArrayList();
            i = 0;
            for(i = 1; i <= 4; ++i) {
                List<MaterialInformation> materialInformation_list = this.materialInformationDao.listMaterialInformationBySpaceMessageIDAndClassIDAndOrder1(spaceMessageID, classID, i);
                if (materialInformation_list.size() != 0) {
                    materialInformation_order_list.add(materialInformation_list.get(0));
                    if (informationID.equals(((MaterialInformation)materialInformation_list.get(0)).getInformationID())) {
                        i = ((MaterialInformation)materialInformation_list.get(0)).getOrder1();
                    }
                } else {
                    if (i >= order1) {
                        break;
                    }

                    materialInformation_order_list.add((Object)null);
                }
            }

            if (i != 0) {
                for(i = 0; i < materialInformation_order_list.size(); ++i) {
                    if (materialInformation_order_list.get(i) != null && ((MaterialInformation)materialInformation_order_list.get(i)).getOrder1() > i) {
                        this.materialInformationDao.updateMaterialInformationOrder1(((MaterialInformation)materialInformation_order_list.get(i)).getInformationID(), i);
                    }
                }
            }
        }

    }
}
